/* $Id: XtConf.h,v 1.1 2006/02/02 15:37:57 jsato Exp $ */
/*
 * Copyright (C) 2006 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * 2006/02/03 jsato: created
 *
 */


#ifndef XT_CONF_H
#define XT_CONF_H

#include <qstring.h>
#include <qvaluelist.h>


class XtConf {

public:
  XtConf();

  void setGroupName(QString);
  void setGroupServer(QString);
  void setGroupPort(Q_UINT16);
  void setVicCmd(QString);
  void setVicPort(Q_UINT16);
  void setVicTTL(Q_UINT16);
  void setRatCmd(QString);
  void setRatPort(Q_UINT16);
  void setRatTTL(Q_UINT16);
  void setKeepAliveTime(Q_UINT32);
  void setUpdateTime(Q_UINT32);
  void setIfName(QString);

  QString  getGroupName();
  const char *getGroupNameChar();
  QString  getGroupServer();
  const char *getGroupServerChar();
  Q_UINT16 getGroupPort();
  QString  getVicCmd();
  const char *getVicCmdChar();
  Q_UINT16 getVicPort();
  Q_UINT16 getVicTTL();
  QString  getRatCmd();
  const char *getRatCmdChar();
  Q_UINT16 getRatPort();
  Q_UINT16 getRatTTL();
  Q_UINT32 getKeepAliveTime();
  Q_UINT32 getUpdateTime();
  QString     getIfName();
  const char  *getIfNameChar();

  QString             getIfAddr();
  QString             getIfAddr(QString);
  Q_UINT16            getIfPrefix();
  QValueList<QString> getIfNameAll();
  bool                hasIfAddr();
  bool                hasIfPrefix();

private:

  QString   groupName;
  QString   groupServer;
  Q_UINT16  groupPort;
  QString   vicCmd;
  Q_UINT16  vicPort;
  Q_UINT16  vicTTL;
  QString   ratCmd;
  Q_UINT16  ratPort;
  Q_UINT16  ratTTL;
  Q_UINT32  keepAliveTime;
  Q_UINT32  updateTime;
  QString   ifName;
  QString   ifAddr;
  Q_UINT16  ifPrefix;
  QString   os_type;

  QValueList<QString> getifname();
  QString   getlocal(QString);
};

#endif /* XT_CONF_H */
