/* $Id: XtHttp.h,v 1.1 2006/02/02 15:37:57 jsato Exp $ */
/*
 * Copyright (C) 2006 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * 2006/02/03 jsato: created
 *
 */


#ifndef XT_HTTP_H
#define XT_HTTP_H

#include <qobject.h>
#include <qdns.h>
#include <qsocketdevice.h>


class XtHttp: public QObject
{
  Q_OBJECT

public:
  XtHttp(QString srv, Q_UINT16 port);
  ~XtHttp();

  void get(QString url, bool grp_get);
  void stop();

signals:
  void sigSendEnd();
  void sigSendData(const char *data, Q_ULONG len);
  void sigSendErr(Q_UINT8 ret);

public slots:
  void httpGet();
  void httpGetMember();
  void httpUpdate(QString srv, Q_UINT16 port);

private:
  QString      sock_srv;
  Q_UINT16     sock_port;
  QSocketDevice *sock;
  QDns          *sock_dns;
  QString      http_url;
  char         recv_buf[2048];
  Q_ULONG      recv_len;

  Q_UINT8 doHttp();
  void    stopHttp();
  void    httpBuild(QString *httpHdr, QString url);
  Q_UINT8 httpResp(const char *data, Q_ULONG len);
};

#endif /* XT_HTTP_H */
